//
// Example Micosoft Flight Simulator 2002 Module
//
// Copyright 2001-2002 Joel M. DeYoung
// This code may be freely distributed and modified provided this notice
// remains unchanged.
//
// This is the minimal amount of code required to get Microsoft Flight Simulator
// to load a DLL that is placed in the modules subdirectory under the main
// FS directory.
//


#ifndef FSMODULE_H_
#define FSMODULE_H_

#include <windows.h>


// We must specify this alignment directive
//
#pragma pack(4)


// Some defines
//
typedef int ID;
typedef unsigned int VAR32;
typedef VAR32 FLAGS32;
#define	FSAPI __stdcall

// These are the functions called when loading and unloading the module
//
extern void FSAPI module_init ();
extern void FSAPI module_deinit ();

// These are the two structs that are exported from the DLL
//
typedef struct IMPORTTABLE
{
    struct
    {
        ID fnID;
        PVOID fnPtr;
    } dummy;
} IMPORTTABLE;
__declspec (dllexport) IMPORTTABLE ImportTable;

typedef struct LINKAGE
{
    ID ModuleID;
    void (FSAPI *ModuleInit) ();
    void (FSAPI *ModuleDeInit) ();
    FLAGS32 ModuleFlags;
    UINT32 ModulePriority;
    UINT32 ModuleVersion;
    LPVOID* Table[];
} LINKAGE;
__declspec (dllexport) LINKAGE Linkage;


#pragma pack ()


#endif


